# Gekko Crypto Monitorring App.
 
## Description
Gekko crypto monitorring app is a Python program that creates a simple GUI that allows the user to select a cryptocurrency and plot its historical price data in various graph types such as line plot, histogram, and box plot. The program uses the tkinter library for creating the GUI and the requests, seaborn, pandas, and matplotlib libraries for retrieving, cleaning, and plotting data.

The program retrieves a list of cryptocurrency names from the CoinGecko API and populates a list box in the GUI with these names. When the user selects a cryptocurrency and a graph type, the program retrieves the historical price data for the selected cryptocurrency using the CoinGecko API and plots the data in the selected graph type.

## Data Sources
coingecko api = 'https://api.coingecko.com/api/v3/coins/'
 
## Running the Application
You can install dependencies by following command.
```
pip install -r requirements.txt
```

## Design
The Gekko app is for a cryptocurrency price graphing tool, built using the Python programming language and the tkinter, requests, seaborn, pandas, and matplotlib libraries. It is designed to allow users to select a cryptocurrency from a list of options and display its price chart using one of three different graph types: a histogram, a line plot, or a box plot.

 
## Design Patterns Used
The Gekko cryptocurrency monitoring application follows the Singleton design pattern, which is a type of creational design pattern that allows for the creation of a single instance of a class. This ensures that there is only one instance of the class throughout the lifetime of the application, and provides a way for other parts of the application to access this instance globally.
 
## Graph Algorithm Used
You have a portfolio of cryptocurrencies and you want to know the most efficient way to convert your holdings into a target cryptocurrency, taking into account the exchange rates between the cryptocurrencies. Given a starting cryptocurrency and a target cryptocurrency, find the shortest path between the two, such that the path consists of no more than three edges. Return the sequence of cryptocurrencies and exchange rates that you should use to convert your holdings into the target cryptocurrency, such that you minimize your trading fees.

Vertices: Cryptocurrencies supported by Coingecko API

Edges: The edges between the vertices represent the exchange rates between the cryptocurrencies.

Associated Values: The edge weights represent the exchange rates between the cryptocurrencies.

Problem: Find the shortest path between two cryptocurrencies, such that the path consists of no more than three edges (i.e., at most two intermediate cryptocurrencies between the two given cryptocurrencies).

Algorithm: We can use Dijkstra's algorithm to find the shortest path between two cryptocurrencies, given that we have a weighted graph of exchange rates between the cryptocurrencies. We can modify the algorithm to terminate early if the path length exceeds three edges, and return the shortest path found within the specified limit. To implement this, we can maintain a count of the number of edges traversed so far, and terminate the search if this count exceeds three. If we find a path with two intermediate cryptocurrencies that satisfies the constraints, we can return this path as the shortest path. If we don't find such a path within the specified limit, we can return a message indicating that no such path was found.

Running time: O(ElogV)
